From a887367d63166267e0b8988df204fdc83c5d7ae7 Mon Sep 17 00:00:00 2001
From: Miroslav Urbanek <mu@miroslavurbanek.com>
Date: Fri, 9 Sep 2016 11:50:27 +0200
Subject: [PATCH] Explicitly enable timestamps in the ALSA backend

Fixes negative values in xrun reports on Linux kernels 4.0 and above.
---
 drivers/alsa/alsa_driver.c | 5 +++++
 1 file changed, 5 insertions(+)

diff --git a/drivers/alsa/alsa_driver.c b/drivers/alsa/alsa_driver.c
index 2f42e31..89b4df3 100644
--- a/drivers/alsa/alsa_driver.c
+++ b/drivers/alsa/alsa_driver.c
@@ -573,6 +573,11 @@ alsa_driver_configure_stream (alsa_driver_t *driver, char *device_name,
 		return -1;
 	}
 
+	if ((err = snd_pcm_sw_params_set_tstamp_mode(handle, sw_params, SND_PCM_TSTAMP_ENABLE)) < 0) {
+		jack_error("ALSA: cannot set tstamp mode for %s", stream_name);
+		return -1;
+	}
+
 	if ((err = snd_pcm_sw_params (handle, sw_params)) < 0) {
 		jack_error ("ALSA: cannot set software parameters for %s\n",
 			    stream_name);
-- 
2.1.4


